﻿using UnityEngine;
using System.Collections;

public class Girl : MonoBehaviour {

	public int position = 6;

	public int velocity = 100;

	private float cooldownTimer;
	public float waitingTime = 70.0f;

	private int countChangePosition = 0;
	public int NUMBER_OF_CHANGES_TO_EXORCISM = 5;


	public GameObject positionGM;
	private bool changing = false;

	public int devilPower = 3;

	public bool paused = false;

	// Use this for initialization
	void Start () {
		
	}
	
	// Update is called once per frame
	void Update () {
		prepareChangePosition ();
		changePosition ();
	}

	void prepareChangePosition() {
		if (canChange ()) {
			position = searchPosition ();
			positionGM = GameObject.Find ("Position" + position);
			changing = true;


			GetComponent<AudioSource>().Play();
			GetComponent<Animator>().SetBool("walking", true);

			countChangePosition++;
			downDevilPower();
		}
	}

	int searchPosition() {
		int randomPositionIndex = position;
		do {
			randomPositionIndex = Random.Range (1, 9);
		} while(randomPositionIndex == position);
		position = randomPositionIndex;
		return position;
	}


	void changePosition () {
		if(changing && paused == false) {
			GetComponent<BoxCollider2D>().isTrigger = true;
//			gameObject.tag = "GirlWalking";
			gameObject.transform.position = Vector3.Lerp(gameObject.transform.position, 
			                                             positionGM.transform.position, 
				                                             1/(velocity * (Vector3.Distance(gameObject.transform.position, positionGM.transform.position))));
			if (gameObject.transform.position == positionGM.transform.position) {
				changing = false;

				GetComponent<Animator>().SetBool("walking", false);
//				gameObject.tag = "Girl";
				GetComponent<BoxCollider2D>().isTrigger = false;
				
			}
		}

	}

	private bool canChange () {
		cooldownTimer += Time.deltaTime;
		if(cooldownTimer > waitingTime){
			cooldownTimer = 0;
			return true;
		}
		return false;
	}

	public void upDevilPower() {
		if (devilPower < 5) {
			devilPower++;
			countChangePosition = 0;
		}
		if (devilPower == 5) {
			GameObject.Find ("GameControler").SendMessage("gameOver");
		}

		GameObject.Find ("DevilPower").SendMessage("changeBar");
		changeAnimation ();

	}

	public void downDevilPower() {
		if(countChangePosition % NUMBER_OF_CHANGES_TO_EXORCISM == 0) {
			if(devilPower >1) {
				devilPower--;
				changeAnimation ();
				GameObject.Find ("DevilPower").SendMessage("changeBar");
			}
		}
	}
	
	void changeAnimation () {
		switch (devilPower) {
		case 1: GetComponent<Animator>().SetInteger("devilPower", 1); break;
		case 2: GetComponent<Animator>().SetInteger("devilPower", 2); break;
		case 3: GetComponent<Animator>().SetInteger("devilPower", 3); break;
		case 4: GetComponent<Animator>().SetInteger("devilPower", 4); break;
		}
	}

	void OnPauseGame () {
		paused = true;
	}

	void OnUnpauseGame () {
		paused = false;
	}
}
