﻿using UnityEngine;
using System.Collections;

public class RespawnControler : MonoBehaviour {

	public GameObject impRef;
	public Girl girl;

	public Canvas canvas;
	
	private float cooldownTimer;
	private float waitingTime;
	private int respawns = 0;
	private int maxImps = 2;

	public int MAX_IMPS = 5;
	public float INIT_WAITING_TIME = 2.0f;
	public int NUM_RESPAWNS_TO_REDUCE_TIME = 10;
	public int NUM_RESPAWNS_TO_UP_MAX_IMPS = 30;

	public ArrayList positions = new ArrayList ();

	// Use this for initialization
	void Start () {
		initRespawn ();
	}
	
	// Update is called once per frame
	void Update () {
		respawnRoutine ();
	}

	void initRespawn() {
		waitingTime = INIT_WAITING_TIME;
	}

	void respawnImp () {
		int position = searchPosition ();
		GameObject positionGM = GameObject.Find("Position" + position);
		GameObject imp = Instantiate (impRef) as GameObject;
		imp.transform.SetParent(positionGM.transform, false);
		imp.transform.localPosition = positionGM.transform.position;
		imp.transform.localRotation = positionGM.transform.rotation;
		positions.Add (position);
	}

	void respawnImpsBySameTime () {
		int respawnsSameTime = Random.Range(maxImps-1, maxImps);
		for( int i = 0; i < respawnsSameTime; i++) {
			respawnImp ();
		}
		positions.Clear ();
	}

	private void respawnRoutine () {
		cooldownTimer += Time.deltaTime;
		if(cooldownTimer > waitingTime){

			respawnImpsBySameTime();

			cooldownTimer = 0;
			respawns++;

			adjustRespawnTimeAndMaxImps ();

		}
	}

	private void adjustRespawnTimeAndMaxImps () {

		if(respawns % NUM_RESPAWNS_TO_REDUCE_TIME == 0) {
			waitingTime = waitingTime - 0.2f;
			Debug.Log ("Tempo reduzido: " + waitingTime);
		}

		if(respawns % NUM_RESPAWNS_TO_UP_MAX_IMPS == 0) {
			if(maxImps < MAX_IMPS) {
				maxImps++;
				waitingTime = INIT_WAITING_TIME;
			}
			Debug.Log ("Imps Aumentados: " + maxImps);
		}
	}

	int searchPosition() {
		int girlPosition = girl.position;
		int randomPositionIndex = girlPosition;
		do {
			randomPositionIndex = Random.Range (1, 9);
		} while(randomPositionIndex == girlPosition || inPositions(randomPositionIndex));
		return randomPositionIndex;
	}

	bool inPositions (int position) {
		foreach(int positionRespawned in positions) {
			if(positionRespawned == position) {
				return true;
			}
		}
		return false;
	}
	
}
